package com.muyu.server.data.mysql;



import com.muyu.common.domain.DataValue;
import com.muyu.common.domain.enums.DataType;
import com.muyu.server.data.base.BaseDataAbsSource;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;


/**
 * @Author：
 * @Package：com.muyu.etl.property.mysql
 * @Project：cloud-etl-property
 * @name：MysqlDataSource
 * @Date：2024/8/29 16:04
 *
 * mysql数据源
 */


public class MySqlDataSource extends BaseDataAbsSource
{


    @Override
    public DataValue getDateValue() {
        MySqlQuery query = getQuery();
        query.getDataSourceId();
        String sql = query.getSql();
        Map<String, Object> queryParams = query.getParams();
        Connection connection=null;
        List<DataValue> dataValueList = new ArrayList<>();
        try {
            PreparedStatement preparedStatement = connection.prepareStatement(sql);
            ResultSet resultSet = preparedStatement.getResultSet();

            ResultSetMetaData metaData = resultSet.getMetaData();
            int columnCount = metaData.getColumnCount();
            while (resultSet.next()){
                for (int i = 0; i < columnCount; i++) {
                    String columnTypeName = metaData.getColumnTypeName(i);
                    // 构建DataValue对象
                    DataValue build = DataValue.builder()
                            .key(resultSet.getCursorName())// 使用游标的名称作为键
                            .label("")// 标签为空
                            .value(resultSet.getObject(resultSet.getCursorName(), DataType.convertType(columnTypeName)))
//                        .type("" +"String");// 数据类型为String
                            .build();
                    dataValueList.add(build);
                }
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }

        return null;
    }

    @Override
    public DataValue[] getRow() {
        return new DataValue[0];
    }

    @Override
    public DataValue[][] fetRows() {
        return new DataValue[0][];
    }

}
